/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.text.NumberFormat;

public class Numero {

	private static final int decimales=1;
	public static final Double notaMax=10.0;
	public static String validarNumeroDecimal(String n,Double maximo,boolean vacio){
		String resultado=null;
		Double valor=null;
		if (n!=null) if (n.isEmpty()) {
			if (vacio) resultado=n;
		} else {
			try {
				valor=Numero.numeroDecimal(n);
				if (maximo!=null) {
					if (valor!=null) if (valor<=maximo) resultado=Numero.cadena(valor);
				} else {
					if (valor!=null) resultado=Numero.cadena(valor);
				}
			} catch (NumberFormatException nfe) {
				//System.out.println("El valor ("+n+") no es un número valido.");
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+n+","+maximo+","+vacio+") ["+valor+"]=> "+resultado);
		return resultado;
	}
	public static String validarNumeroEntero(String n, Double maximo,boolean vacio){
		String resultado=null;
		Integer valor=null;
		//System.out.println("validarNumeroEntero n["+n+"] !empty="+(!n.isEmpty())+" PuedeSerVvacio="+vacio);
		if (n!=null) if (n.isEmpty()) {
			if (vacio) resultado=n;
		} else {
			try {
				valor=Numero.numeroEntero(n);
				if (maximo!=null) {
					if (valor!=null) if (valor<=maximo) resultado=valor.toString();
				} else {
					if (valor!=null) resultado=valor.toString();
				}
				
			} catch (NumberFormatException nfe) {
				//System.out.println("El valor ("+n+") no es un número valido => "+resultado);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+n+","+maximo+","+vacio+") ["+valor+"]=> "+resultado);
		return resultado;
	}
	public static String cadena(Double d){
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMaximumFractionDigits(Numero.decimales);
		return nf.format(d);
	}
	public static Double numeroDecimal(String c){
		return Double.parseDouble(c.replace(".", "").replace(",", "."));
	}
	public static Integer numeroEntero(String c){
		return Integer.parseInt(c.replace(".", ""));
	}
	public static String cadenaDecimal(Double d){
		return (String.valueOf(d).replace(".", ","));
	}
	public static String cadenaEntero(Integer d){
		return (String.valueOf(d).replace(".", ","));
	}
}
